//
// XMM Science Analysis System
//
// Giuseppe Vacanti (European Space Agency) 
// July 30, 1999
//
#ifndef CalIndexSet_H
#define CalIndexSet_H

#include <string>
#include <Dal.h>
#include <STime.h>

#include "CalIndex.h"

#include "CcfConstituent.h"

class CalIndexSet {

 public:

  CalIndexSet(const string& name, const bool& master,
	      const bool& fullpath, const string& category,
	      const STime& analysisdate = STime("now"),
	      const STime& observationdate = STime("now"));
  CalIndexSet(const string& name, const bool& readonly=false);
  ~CalIndexSet() {};

  CalIndex calibrationIndex(const string& name) const;

  void insert(CcfConstituent * c);
  void close();
  unsigned long size() const;
  CcfConstituent * getConstituent(const unsigned int& row) const;
  
 private:

  bool _can_insert, _fullpath, _master;
  DataSet * _set;
  string _category;

};

#endif
