//
// XMM Science Analysis System
//
// Giuseppe Vacanti (European Space Agency) 
// April 04, 2000
//
#include "cifremove.h"
#include <Tracer.h>
#include <string>
#include "CalIndexSet.h"
#include <param.h>
#include <errstr.h>

void cifremove() {
  PROC
  if(parameterCount("scopes") != parameterCount("types"))
    errstr << "The number of scopes (" << parameterCount("scopes") << ") does not match the number of types (" << parameterCount("types") << ")." <<Sas::error("ParameterCountMismatch");
  string s = stringParameter("calindexset");
  CalIndexSet cset = CalIndexSet(s);
  CalIndex cif = cset.calibrationIndex(s);
  cset.close(); // must close it, or it cannot be overwritten
  for(int i = 0; i < parameterCount("scopes"); i++){
    if(!cif.removeConstituent(stringParameter("types",i),stringParameter("scopes",i)))
      errstr << s << " contains no constituent matching " << stringParameter("types",i) << "/" << stringParameter("scopes",i) << Sas::warning("NoMatchingCcfConstituent");
  }
  cif.save();
  ENDPROC
}
